<script lang="ts" setup>
import GrafanaApiV1 from '@/api/grafana/getDashDb';
import { onMounted, ref } from 'vue';

// Variables de estado
const checkbox = ref(false); // Para el checkbox
const buttonLabel = ref('Descargar'); // Estado para el texto del botón
const selectedFile = ref<File | null>(null); // Para almacenar el archivo seleccionado
const data = ref(null); // Para almacenar los datos obtenidos de la API

// Crear instancia de GrafanaApiDB


// Método async para crear un token
const getDBList = async () => {
  console.info('INFO: createToken')
  console.info('***************** Alex: vamos a ver si entramos a la api de grafana')
  const getjsonlist = new GrafanaApiV1()
  console.info('***************** Alex: tenemos token: ', getjsonlist)
  try {
    const response = await getjsonlist.fetchDashboards()
    console.debug('createToken response.data', response.data)
  }
  catch (error) {
    console.debug('error getDBList', error.response.data)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
}

// Función para manejar el cambio del archivo
const handleFileChange = async (event: Event) => {
  const file = (event.target as HTMLInputElement).files?.[0];
  if (file) {
    selectedFile.value = file;

    // Leer el contenido del archivo JSON
    const reader = new FileReader();
    reader.onload = (e) => {
      const result = e.target?.result as string;
      try {
        const jsonData = JSON.parse(result);
        console.log('Archivo JSON cargado:', jsonData);

        // Guardar en localStorage
        localStorage.setItem('dashboards', JSON.stringify(jsonData));
        checkbox.value = true; // Marcar el checkbox como seleccionado
        buttonLabel.value = 'Actualizar'; // Cambiar el texto del botón a 'Actualizar'
      } catch (error) {
        console.error('Error al parsear el archivo JSON:', error);
      }
    };
    reader.readAsText(file);
  }
};

// Función para verificar si ya existe el JSON en localStorage
const checkLocalStorage = () => {
  const storedJson = localStorage.getItem('dashboards');
  if (storedJson) {
    checkbox.value = true; // Si existe el JSON, marcar el checkbox como true
    buttonLabel.value = 'Actualizar'; // Cambiar el texto del botón a 'Actualizar'
    console.log('JSON encontrado en localStorage');
  } else {
    checkbox.value = false; // Si no existe, dejar el checkbox desmarcado
    buttonLabel.value = 'Descargar'; // Cambiar el texto del botón a 'Descargar'
    console.log('JSON no encontrado en localStorage');
  }
};

const CargarData = async () => {
  try {
    await getDBList(); // Asegúrate de esperar la ejecución
  } catch (error) {
    console.error('Error al cargar los datos de Grafana:', error);
  }
};

// Ejecutar al montar el componente
onMounted(() => {

  checkLocalStorage(); // Verificar si el JSON ya está en localStorage
});


</script>

<template>
  <VForm @submit.prevent="() => {}">
    <VRow>
      <!-- Checkbox for JSON loaded -->
      <VCol cols="12">
        <VCheckbox
          v-model="checkbox"
          label="Json loaded"
          disabled  
        />
      </VCol>
      
      <VCol cols="12" class="d-flex gap-4">
        <!-- Input para seleccionar el archivo JSON -->
        <input type="file" accept=".json" @change="handleFileChange" hidden ref="fileInput" />
        
        <!-- Botón para descargar o actualizar el JSON -->
        <VBtn @click="$refs.fileInput.click()">
          {{ buttonLabel }} <!-- Mostrar el texto dinámico del botón -->
          <VIcon
            end
            icon="tabler-cloud-download"
          />
        </VBtn>



        <!-- Mostrar los datos obtenidos -->
        <pre v-if="data">{{ data }}</pre>
      </VCol>
    </VRow>
  </VForm>
</template>
